#include "md5.h"
/*
 * Return index position in alphabet
 */
int get_index(char *string, char ch) {
	int i = 0;
	while(string[i]) {
		if(ch == string[i]) {
			return(i);
		}
		i++;
	}
	return(i);
}

char fasthex[]="0123456789abcdef";
void mdstring(char *output, unsigned char *hash){
	int i, j;
	for(i=0; i<16 ; i++){
		j = hash[i];
		output[i*2] = fasthex[(j>>4)&0x0f];
		output[i*2+1] = fasthex[j&0x0f];
	}
	output[32] = '\0';
}



void BeginBrute(char Alphabet[], char TargetMD5[], int MaxPasswordLength) {
	
	int a,b,c;
	char Password[14];
	unsigned char sumbuf[16] ;
	char md5buf[33];
	
	for (a = 0; a < MaxPasswordLength; a++) {
		for(b=0; b <= a; b++) {
			Password[b]=Alphabet[0];
		}
		Password[b]='\0';
		
		b=0;	/* Start at position zero */
		while(b <= a) {
			if(!b) {
				/* Generate MD5 Hash */
				MD5_CTX mycontext;
				MD5_Init(&mycontext);

				MD5_Update(&mycontext, Password, strlen(Password));
				MD5_Final(sumbuf, &mycontext);

				mdstring(md5buf, sumbuf);
				/*Generate MD5 Hash */
				printf("[%s] [%s] [%s]\n", Password, md5buf, TargetMD5); /* Print out the password */
				
					if (strcmp(md5buf, TargetMD5) == 0) {
						printf("Done.\n");
						exit(0);
					}

			}
			
			c = get_index(Alphabet, Password[b]);
			c++;
			
			if(c >= strlen(Alphabet)) {
				Password[b] = Alphabet[0];	/* Reset this to first char */
				b++;				/* increment POSITION */
				continue;			/* and keep going with loop */
			}
			Password[b] = Alphabet[c];		/* Set new alpha */
			b = 0;					/* Back to zero position */
		}
	}
}
